manage 15 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517
  1. #!/usr/bin/env bash
  2. # -*- coding: utf-8; mode: sh indent-tabs-mode: nil -*-
  3. # SPDX-License-Identifier: AGPL-3.0-or-later
  4. # shellcheck disable=SC2031
  5. # shellcheck source=utils/lib.sh
  6. source "$(dirname "${BASH_SOURCE[0]}")/utils/lib.sh"
  7. # shellcheck source=utils/brand.env
  8. source "${REPO_ROOT}/utils/brand.env"
  9. source_dot_config
  10. # config
  11. PYOBJECTS="searx"
  12. PY_SETUP_EXTRAS='[test]'
  13. NPM_PACKAGES="less@2.7 less-plugin-clean-css grunt-cli"
  14. GECKODRIVER_VERSION="v0.28.0"
  15. # SPHINXOPTS=
  16. pylint.FILES() {
  17. # List files tagged by comment:
  18. #
  19. # # lint: pylint
  20. #
  21. # These py files are linted by test.pylint(), all other files are linted by
  22. # test.pep8()
  23. grep -l -r --include \*.py '^#[[:blank:]]*lint:[[:blank:]]*pylint' searx searx_extra tests
  24. }
  25. PYLINT_SEARX_DISABLE_OPTION="\
  26. I,C,R,\
  27. W0105,W0212,W0511,W0603,W0613,W0621,W0702,W0703,W1401,\
  28. E1136"
  29. PYLINT_ADDITIONAL_BUILTINS_FOR_ENGINES="supported_languages,language_aliases"
  30. PYLINT_OPTIONS="-m pylint -j 0 --rcfile .pylintrc"
  31. help() {
  32. cat <<EOF
  33. buildenv
  34. rebuild ./utils/brand.env
  35. babel.compile
  36. pybabel compile ./searx/translations
  37. data.*
  38. all : update searx/languages.py and ./data/*
  39. languages : update searx/data/engines_languages.json & searx/languages.py
  40. useragents: update searx/data/useragents.json with the most recent versions of Firefox.
  41. docs.*
  42. html : build HTML documentation
  43. live : autobuild HTML documentation while editing
  44. gh-pages : deploy on gh-pages branch
  45. prebuild : build reST include files (./${DOCS_BUILD}/includes)
  46. clean : clean documentation build
  47. docker
  48. build : build docker image
  49. push : build and push docker image
  50. gecko.driver
  51. download & install geckodriver if not already installed (required for
  52. robot_tests)
  53. node.*
  54. env : download & install npm dependencies locally
  55. clean : drop npm installations
  56. py.*
  57. build : Build python packages at ./${PYDIST}
  58. clean : delete virtualenv and intermediate py files
  59. pyenv.* :
  60. install : developer install of searx into virtualenv
  61. uninstall : uninstall developer installation
  62. cmd ... : run command ... in virtualenv
  63. OK : test if virtualenv is OK
  64. pypi.upload:
  65. Upload python packages to PyPi (to test use pypi.upload.test)
  66. test.* :
  67. pylint : lint PYLINT_FILES, searx/engines, searx & tests
  68. pep8 : pycodestyle (pep8) for all files except PYLINT_FILES
  69. unit : run unit tests
  70. coverage : run unit tests with coverage
  71. robot : run robot test
  72. clean : clean intermediate test stuff
  73. themes.* :
  74. all : build all themes
  75. oscar : build oscar theme
  76. simple : build simple theme
  77. EOF
  78. }
  79. if [ "$VERBOSE" = "1" ]; then
  80. SPHINX_VERBOSE="-v"
  81. PYLINT_VERBOSE="-v"
  82. fi
  83. # needed by sphinx-docs
  84. export DOCS_BUILD
  85. buildenv() {
  86. SEARX_DEBUG=1 pyenv.cmd python utils/build_env.py 2>&1 \
  87. | prefix_stdout "${_Blue}BUILDENV${_creset} "
  88. return "${PIPESTATUS[0]}"
  89. }
  90. babel.compile() {
  91. build_msg BABEL compile
  92. pyenv.cmd pybabel compile -d "${REPO_ROOT}/searx/translations"
  93. dump_return $?
  94. }
  95. data.all() {
  96. data.languages
  97. data.useragents
  98. build_msg DATA "update searx/data/ahmia_blacklist.txt"
  99. pyenv.cmd python searx_extra/update/update_ahmia_blacklist.py
  100. build_msg DATA "update searx/data/wikidata_units.json"
  101. pyenv.cmd python searx_extra/update/update_wikidata_units.py
  102. build_msg DATA "update searx/data/currencies.json"
  103. pyenv.cmd python searx_extra/update/update_currencies.py
  104. }
  105. data.languages() {
  106. ( set -e
  107. build_msg ENGINES "fetch languages .."
  108. pyenv.cmd python searx_extra/update/update_languages.py
  109. build_msg ENGINES "update update searx/languages.py"
  110. build_msg DATA "update searx/data/engines_languages.json"
  111. )
  112. dump_return $?
  113. }
  114. data.useragents() {
  115. build_msg DATA "update searx/data/useragents.json"
  116. pyenv.cmd python searx_extra/update/update_firefox_version.py
  117. dump_return $?
  118. }
  119. docs.prebuild() {
  120. build_msg DOCS "build ${DOCS_BUILD}/includes"
  121. (
  122. set -e
  123. [ "$VERBOSE" = "1" ] && set -x
  124. mkdir -p "${DOCS_BUILD}/includes"
  125. ./utils/searx.sh doc | cat > "${DOCS_BUILD}/includes/searx.rst"
  126. ./utils/filtron.sh doc | cat > "${DOCS_BUILD}/includes/filtron.rst"
  127. ./utils/morty.sh doc | cat > "${DOCS_BUILD}/includes/morty.rst"
  128. )
  129. dump_return $?
  130. }
  131. docker.push() {
  132. docker.build push
  133. }
  134. docker.buildx() {
  135. docker.build buildx
  136. }
  137. # shellcheck disable=SC2119
  138. docker.build() {
  139. pyenv.install
  140. build_msg DOCKER build
  141. # run installation in a subprocess and activate pyenv
  142. # See https://www.shellcheck.net/wiki/SC1001 and others ..
  143. # shellcheck disable=SC2031,SC2230,SC2002,SC2236,SC2143,SC1001
  144. ( set -e
  145. # shellcheck source=/dev/null
  146. source "${PY_ENV_BIN}/activate"
  147. # Check if it is a git repository
  148. if [ ! -d .git ]; then
  149. die 1 "This is not Git repository"
  150. fi
  151. if [ ! -x "$(which git)" ]; then
  152. die 1 "git is not installed"
  153. fi
  154. if ! git remote get-url origin 2> /dev/null; then
  155. die 1 "there is no remote origin"
  156. fi
  157. # This is a git repository
  158. # "git describe" to get the Docker version (for example : v0.15.0-89-g0585788e)
  159. # awk to remove the "v" and the "g"
  160. SEARX_GIT_VERSION=$(git describe --match "v[0-9]*\.[0-9]*\.[0-9]*" HEAD 2>/dev/null | awk -F'-' '{OFS="-"; $1=substr($1, 2); if ($3) { $3=substr($3, 2); } print}')
  161. # add the suffix "-dirty" if the repository has uncommited change
  162. # /!\ HACK for searx/searx: ignore utils/brand.env
  163. git update-index -q --refresh
  164. if [ ! -z "$(git diff-index --name-only HEAD -- | grep -v 'utils/brand.env')" ]; then
  165. SEARX_GIT_VERSION="${SEARX_GIT_VERSION}-dirty"
  166. fi
  167. # Get the last git commit id, will be added to the Searx version (see Dockerfile)
  168. VERSION_GITCOMMIT=$(echo "$SEARX_GIT_VERSION" | cut -d- -f2-4)
  169. build_msg DOCKER "Last commit : $VERSION_GITCOMMIT"
  170. # Check consistency between the git tag and the searx/version.py file
  171. # /! HACK : parse Python file with bash /!
  172. # otherwise it is not possible build the docker image without all Python
  173. # dependencies ( version.py loads __init__.py )
  174. # SEARX_PYTHON_VERSION=$(python3 -c "import six; import searx.version; six.print_(searx.version.VERSION_STRING)")
  175. SEARX_PYTHON_VERSION=$(cat searx/version.py | grep "\(VERSION_MAJOR\|VERSION_MINOR\|VERSION_BUILD\) =" | cut -d\= -f2 | sed -e 's/^[[:space:]]*//' | paste -sd "." -)
  176. if [ "$(echo "$SEARX_GIT_VERSION" | cut -d- -f1)" != "$SEARX_PYTHON_VERSION" ]; then
  177. err_msg "git tag: $SEARX_GIT_VERSION"
  178. err_msg "searx/version.py: $SEARX_PYTHON_VERSION"
  179. die 1 "Inconsistency between the last git tag and the searx/version.py file"
  180. fi
  181. # define the docker image name
  182. GITHUB_USER=$(echo "${GIT_URL}" | sed 's/.*github\.com\/\([^\/]*\).*/\1/')
  183. SEARX_IMAGE_NAME="${SEARX_IMAGE_NAME:-${GITHUB_USER:-searxng}/searxng}"
  184. BUILD="build"
  185. if [ "$1" = "buildx" ]; then
  186. # buildx includes the push option
  187. CACHE_TAG="${SEARX_IMAGE_NAME}:latest-build-cache"
  188. BUILD="buildx build --platform linux/amd64,linux/arm64,linux/arm/v7 --push --cache-from=type=registry,ref=$CACHE_TAG --cache-to=type=registry,ref=$CACHE_TAG,mode=max"
  189. shift
  190. fi
  191. build_msg DOCKER "Build command: ${BUILD}"
  192. # build Docker image
  193. build_msg DOCKER "Building image ${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}"
  194. # shellcheck disable=SC2086
  195. docker $BUILD \
  196. --build-arg BASE_IMAGE="${DEPENDENCIES_IMAGE_NAME}" \
  197. --build-arg GIT_URL="${GIT_URL}" \
  198. --build-arg SEARX_GIT_VERSION="${SEARX_GIT_VERSION}" \
  199. --build-arg VERSION_GITCOMMIT="${VERSION_GITCOMMIT}" \
  200. --build-arg LABEL_DATE="$(date -u +"%Y-%m-%dT%H:%M:%SZ")" \
  201. --build-arg LABEL_VCS_REF="$(git rev-parse HEAD)" \
  202. --build-arg LABEL_VCS_URL="${GIT_URL}" \
  203. --build-arg TIMESTAMP_SETTINGS="$(git log -1 --format="%cd" --date=unix -- searx/settings.yml)" \
  204. --build-arg TIMESTAMP_UWSGI="$(git log -1 --format="%cd" --date=unix -- dockerfiles/uwsgi.ini)" \
  205. -t "${SEARX_IMAGE_NAME}:latest" -t "${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}" .
  206. if [ "$1" = "push" ]; then
  207. docker push "${SEARX_IMAGE_NAME}:latest"
  208. docker push "${SEARX_IMAGE_NAME}:${SEARX_GIT_VERSION}"
  209. fi
  210. )
  211. dump_return $?
  212. }
  213. # shellcheck disable=SC2119
  214. gecko.driver() {
  215. pyenv.install
  216. build_msg INSTALL "gecko.driver"
  217. # run installation in a subprocess and activate pyenv
  218. ( set -e
  219. # shellcheck source=/dev/null
  220. source "${PY_ENV_BIN}/activate"
  221. # TODO : check the current geckodriver version
  222. geckodriver -V > /dev/null 2>&1 || NOTFOUND=1
  223. set +e
  224. if [ -z "$NOTFOUND" ]; then
  225. build_msg INSTALL "geckodriver already installed"
  226. return
  227. fi
  228. PLATFORM="$(python3 -c 'import platform; print(platform.system().lower(), platform.architecture()[0])')"
  229. case "$PLATFORM" in
  230. "linux 32bit" | "linux2 32bit") ARCH="linux32";;
  231. "linux 64bit" | "linux2 64bit") ARCH="linux64";;
  232. "windows 32 bit") ARCH="win32";;
  233. "windows 64 bit") ARCH="win64";;
  234. "mac 64bit") ARCH="macos";;
  235. esac
  236. GECKODRIVER_URL="https://github.com/mozilla/geckodriver/releases/download/$GECKODRIVER_VERSION/geckodriver-$GECKODRIVER_VERSION-$ARCH.tar.gz";
  237. build_msg GECKO "Installing ${PY_ENV_BIN}/geckodriver from $GECKODRIVER_URL"
  238. FILE="$(mktemp)"
  239. wget -qO "$FILE" -- "$GECKODRIVER_URL" && tar xz -C "${PY_ENV_BIN}" -f "$FILE" geckodriver
  240. rm -- "$FILE"
  241. chmod 755 -- "${PY_ENV_BIN}/geckodriver"
  242. )
  243. dump_return $?
  244. }
  245. node.env() {
  246. local err=0
  247. pushd "${REPO_ROOT}" &> /dev/null
  248. # shellcheck disable=SC2230
  249. which npm &> /dev/null || die 1 'node.env - npm is not found!'
  250. ( set -e
  251. # shellcheck disable=SC2030
  252. PATH="$(npm bin):$PATH"
  253. export PATH
  254. build_msg INSTALL "npm install $NPM_PACKAGES"
  255. # shellcheck disable=SC2086
  256. npm install $NPM_PACKAGES
  257. cd "${REPO_ROOT}/searx/static/themes/oscar"
  258. build_msg INSTALL "($(pwd)) npm install"
  259. npm install
  260. build_msg INSTALL "($(pwd)) npm install"
  261. cd "${REPO_ROOT}/searx/static/themes/simple"
  262. npm install
  263. )
  264. err=$?
  265. popd &> /dev/null
  266. dump_return "$err"
  267. }
  268. node.clean() {
  269. build_msg CLEAN "locally installed npm dependencies"
  270. rm -rf \
  271. ./node_modules \
  272. ./package-lock.json \
  273. ./searx/static/themes/oscar/package-lock.json \
  274. ./searx/static/themes/oscar/node_modules \
  275. ./searx/static/themes/simple/package-lock.json \
  276. ./searx/static/themes/simple/node_modules
  277. dump_return $?
  278. }
  279. py.build() {
  280. build_msg BUILD "[pylint] python package ${PYDIST}"
  281. pyenv.cmd python setup.py \
  282. sdist -d "${PYDIST}" \
  283. bdist_wheel --bdist-dir "${PYBUILD}" -d "${PYDIST}"
  284. }
  285. py.clean() {
  286. build_msg CLEAN pyenv
  287. ( set -e
  288. pyenv.drop
  289. [ "$VERBOSE" = "1" ] && set -x
  290. rm -rf "${PYDIST}" "${PYBUILD}" "${PY_ENV}" ./.tox ./*.egg-info
  291. find . -name '*.pyc' -exec rm -f {} +
  292. find . -name '*.pyo' -exec rm -f {} +
  293. find . -name __pycache__ -exec rm -rf {} +
  294. )
  295. }
  296. pyenv.check() {
  297. cat <<EOF
  298. import yaml
  299. print('import yaml --> OK')
  300. EOF
  301. }
  302. pyenv.install() {
  303. if ! pyenv.OK; then
  304. py.clean > /dev/null
  305. fi
  306. if pyenv.install.OK > /dev/null; then
  307. return 0
  308. fi
  309. ( set -e
  310. pyenv
  311. build_msg PYENV "[install] pip install -e 'searx${PY_SETUP_EXTRAS}'"
  312. "${PY_ENV_BIN}/python" -m pip install -e ".${PY_SETUP_EXTRAS}"
  313. buildenv
  314. )
  315. local exit_val=$?
  316. if [ ! $exit_val -eq 0 ]; then
  317. die 42 "error while pip install (${PY_ENV_BIN})"
  318. fi
  319. }
  320. pyenv.uninstall() {
  321. build_msg PYENV "[pyenv.uninstall] uninstall packages: ${PYOBJECTS}"
  322. pyenv.cmd python setup.py develop --uninstall 2>&1 \
  323. | prefix_stdout "${_Blue}PYENV ${_creset}[pyenv.uninstall] "
  324. }
  325. pypi.upload() {
  326. py.clean
  327. py.build
  328. # https://github.com/pypa/twine
  329. pyenv.cmd twine upload "${PYDIST}"/*
  330. }
  331. pypi.upload.test() {
  332. py.clean
  333. py.build
  334. pyenv.cmd twine upload -r testpypi "${PYDIST}"/*
  335. }
  336. test.pylint() {
  337. # shellcheck disable=SC2086
  338. ( set -e
  339. build_msg TEST "[pylint] \$PYLINT_FILES"
  340. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  341. "${PYLINT_FILES[@]}"
  342. build_msg TEST "[pylint] searx/engines"
  343. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  344. --disable="${PYLINT_SEARX_DISABLE_OPTION}" \
  345. --additional-builtins="${PYLINT_ADDITIONAL_BUILTINS_FOR_ENGINES}" \
  346. searx/engines
  347. build_msg TEST "[pylint] searx tests"
  348. pyenv.cmd python ${PYLINT_OPTIONS} ${PYLINT_VERBOSE} \
  349. --disable="${PYLINT_SEARX_DISABLE_OPTION}" \
  350. --ignore=searx/engines \
  351. searx tests
  352. )
  353. dump_return $?
  354. }
  355. test.pep8() {
  356. build_msg TEST 'pycodestyle (formerly pep8)'
  357. local _exclude=""
  358. printf -v _exclude '%s, ' "${PYLINT_FILES[@]}"
  359. pyenv.cmd pycodestyle \
  360. --exclude="searx/static, searx/languages.py, $_exclude " \
  361. --max-line-length=120 \
  362. --ignore "E117,E252,E402,E722,E741,W503,W504,W605" \
  363. searx tests
  364. dump_return $?
  365. }
  366. test.unit() {
  367. build_msg TEST 'tests/unit'
  368. pyenv.cmd python -m nose2 -s tests/unit
  369. dump_return $?
  370. }
  371. test.coverage() {
  372. build_msg TEST 'unit test coverage'
  373. ( set -e
  374. pyenv.cmd python -m nose2 -C --log-capture --with-coverage --coverage searx -s tests/unit
  375. pyenv.cmd coverage report
  376. pyenv.cmd coverage html
  377. )
  378. dump_return $?
  379. }
  380. test.robot() {
  381. build_msg TEST 'robot'
  382. gecko.driver
  383. PYTHONPATH=. pyenv.cmd python searx/testing.py robot
  384. dump_return $?
  385. }
  386. test.clean() {
  387. build_msg CLEAN "test stuff"
  388. rm -rf geckodriver.log .coverage coverage/
  389. dump_return $?
  390. }
  391. themes.all() {
  392. ( set -e
  393. node.env
  394. themes.oscar
  395. themes.simple
  396. )
  397. dump_return $?
  398. }
  399. themes.oscar() {
  400. local gruntfile=searx/static/themes/oscar/gruntfile.js
  401. build_msg GRUNT "${gruntfile}"
  402. PATH="$(npm bin):$PATH" grunt --gruntfile "${gruntfile}"
  403. dump_return $?
  404. }
  405. themes.simple() {
  406. local gruntfile=searx/static/themes/simple/gruntfile.js
  407. build_msg GRUNT "${gruntfile}"
  408. PATH="$(npm bin):$PATH" grunt --gruntfile "${gruntfile}"
  409. dump_return $?
  410. }
  411. PYLINT_FILES=()
  412. while IFS= read -r line; do
  413. PYLINT_FILES+=("$line")
  414. done <<< "$(pylint.FILES)"
  415. # shellcheck disable=SC2119
  416. main() {
  417. local _type
  418. local cmd="$1"; shift
  419. if [ "$cmd" == "" ]; then
  420. help
  421. err_msg "missing command"
  422. return 42
  423. fi
  424. case "$cmd" in
  425. --getenv) var="$1"; echo "${!var}";;
  426. --help) help;;
  427. --*)
  428. help
  429. err_msg "unknown option $cmd"
  430. return 42
  431. ;;
  432. *)
  433. _type="$(type -t "$cmd")"
  434. if [ "$_type" != 'function' ]; then
  435. err_msg "unknown command $1 / use --help"
  436. return 42
  437. else
  438. "$cmd" "$@"
  439. fi
  440. ;;
  441. esac
  442. }
  443. main "$@"